/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
* Operator of Los Alamos National Laboratory.
* This file is distributed subject to a Software License Agreement found
* in the file LICENSE that is included with this distribution. 
\*************************************************************************/
package dbStatic;
import dbStatic.DbBase;
import java.lang.*; 

public class DbEntry extends Object {
    /*/*Field types as seen by static database access clients*/
    public static final int DCT_STRING =   0;
    public static final int DCT_INTEGER =  1;
    public static final int DCT_REAL =     2;
    public static final int DCT_MENU =     3;
    public static final int DCT_MENUFORM = 4;
    public static final int DCT_INLINK =   5;
    public static final int DCT_OUTLINK =  6;
    public static final int DCT_FWDLINK =  7;
    public static final int DCT_NOACCESS = 8;
    public static String typeNames[] = new String[DCT_NOACCESS+1];

    /*Link types as seen by static database access clients*/
    public static final int DCT_LINK_CONSTANT =   0;
    public static final int DCT_LINK_FORM =       1;
    public static final int DCT_LINK_PV =         2;

    static {
	typeNames[0] = new String("STRING");
	typeNames[1] = new String("INTEGER");
	typeNames[2] = new String("REAL");
	typeNames[3] = new String("MENU");
	typeNames[4] = new String("DEVICE");
	typeNames[5] = new String("INLINK");
	typeNames[6] = new String("OUTLINK");
	typeNames[7] = new String("FWDLINK");
	typeNames[8] = new String("NOACCESS");
    }

    public DbEntry(DbBase dbBase)
    {
	int indexDbBase;

	indexDbEntry = -1;
	indexDbBase = dbBase.indexDbBase;
	alloc(indexDbBase);
    }
    public native final void free();
    public native final boolean findRecordType(String recordTypename);
    public native final boolean firstRecordType();
    public native final boolean nextRecordType();
    public native final String getRecordTypeName();
    public native final int getNRecordTypes();

    public native final boolean firstField(boolean dctonly);
    public native final boolean nextField(boolean dctonly);
    public native final int getFieldType();
    public native final int getNFields(boolean dctonly);
    public native final String getFieldName();
    public native final String getDefault();
    public native final String getPrompt();
    public native final boolean isDctField();

    public native final void createRecord(String recordName);
    public native final void deleteRecord();
    public native final void freeRecords();
    public native final boolean findRecord(String recordName);
    public native final boolean firstRecord();
    public native final boolean nextRecord();
    public native final int getNRecords();
    public native final String getRecordName();
    public native final void renameRecord(String newRecordName);
    public native final void copyRecord(String newRecordName,boolean overWriteOK);
    public native final void setVisibility(boolean visible);
    public native final boolean getVisibility();

    public native final boolean findField(String fieldName);
    public native final boolean foundField();
    public native final String getString();
    public native final void putString(String value);
    public native final String verify(String value);
    public native final String getRange();
    public native final boolean isDefaultValue();
    public native final int getNMenuChoices();
    public native final int getMenuIndex();
    public native final void putMenuIndex(int index); public native final String getMenuStringFromIndex(int index);
    public native final int getMenuIndexFromString(String value);
    private native final void alloc(int indexDbBase);
    private int indexDbEntry;
    private int allocFormNstrings;
    public native final int getNLinks();  
    public native final boolean getLinkField(int index);
    public native final int getLinkType();
    public native boolean cvtLinkToConstant();
    public native boolean cvtLinkToPvlink();
    public native int allocForm();
    public native boolean freeForm();
    public native String[] getFormPrompt();
    public native String[] getFormValue();
    public native boolean putForm(String[] value);
    public native boolean verifyForm(String[] value, String[] error);
    public native String getRelatedField();
}
